This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 446989 - (python-epsilon) Review Request: python-epsilon - A small utility package that depends on tools too recent for Twisted
Review Request: python-epsilon - A small utility package that depends on tool...
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Yaakov Nemoy
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-DEADREVIEW python-axiom
  Show dependency treegraph
 
Reported: 2008-05-16 16:40 EDT by Mauricio Teixeira
Modified: 2013-02-19 06:02 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-19 06:02:31 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
loupgaroublond: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Mauricio Teixeira 2008-05-16 16:40:40 EDT
Spec URL: http://mteixeira.webset.net/mock/python-epsilon.spec
SRPM URL: http://mteixeira.webset.net/mock/python-epsilon-0.5.9-1.fc9.src.rpm
Description: 
A small utility package that depends on tools too recent for Twisted (like
datetime in python2.4) but performs generic enough functions that it can be
used in projects that don't want to share Divmod's other projects' large
footprint.

Currently included:

    * A powerful date/time formatting and import/export class (ExtimeDotTime),
      for exchanging date and time information between all Python's various
      ways to interpret objects as times or time deltas.
    * Tools for managing concurrent asynchronous processes within Twisted.
    * A metaclass which helps you define classes with explicit states.
    * A featureful Version class.
    * A formal system for application of monkey-patches.

**
This is my first package and I need a sponsor.
This package satisfies dependency from python-axiom and python-coherence.
**
Comment 1 Jason Tibbitts 2008-11-05 22:05:59 EST
I'm sorry that you have not received a response to your submission.  If you are still interested in submitting this package, here are a few comments:

Is there any arch-specific code in this package?  I don't see anything compiled, and there are no binaries included in the final rpm.  Are you sure it shouldn't be noarch?

No version of Fedora less than F8 is supported, so you should simply remove the conditionals that refer to such old versions (especially the FC3 one; that's long dead).  If you intend to build for EPEL then you may need some conditionals for that, but they should be indicated as being for EPEL.  Also, please note that the package doesn't actually work on those old releases; it doesn't even build on F8 because your files list explicitly specifies the egg.info file, when F8 and older don't generate one.

Your files list can be as simple as a single line:
  %{python_sitelib}/*

Is there any particular reason for the complex file list you have now?  As a bonus, that would actually let you build on F8 without conditionalizing.

NAME.txt has DOS line endings and should be converted.
Comment 2 Jason Tibbitts 2008-11-05 22:11:18 EST
Also, the License: tag is not correct.  The LICENSE file contains exact what is termed the "Modern Style with Sublicense" on https://fedoraproject.org/wiki/Licensing/MIT, implying that "License: MIT" is correct.
Comment 3 Jason Tibbitts 2008-11-17 13:55:49 EST
Any response to the above commentary?  Are you still interested in submitting this package?
Comment 4 Mauricio Teixeira 2008-11-21 13:48:29 EST
Jason, sorry for taking so long, but I was very busy.

So, I have updated the package with your suggestions. Regarding the file lists, I just followed the packaging guidelines:

https://fedoraproject.org/wiki/Packaging/Python#Byte_Compiled_Files

Would you please review it again?

Spec URL: http://mteixeira.webset.net/mock/python-epsilon.spec
SRPM URL: http://mteixeira.webset.net/mock/python-axiom-0.5.30-1.fc9.src.rpm

Also, would you please review #446990 and #446991? They're all related.

Thanks!
Comment 5 Jason Tibbitts 2008-12-20 14:49:37 EST
Sorry for not getting back to this earlier; there are so many packages to look at.

You linked to the wrong srpm above; I've found the right one.

I guess when following those packaging guidelines you didn't look at the whole set of examples.  Unless you have some specific reason for using the most verbose and complicated means of constructing your %files list, why not just use the simple one?  I mean, you entire %files list could be the following:
  %files
  %defattr(-,root,root,-)
  %doc README LICENSE NAME.txt NEWS.txt
  %{python_sitelib}/*

rpmlint says:
  python-epsilon.src: W: mixed-use-of-spaces-and-tabs
   (spaces: line 7, tab: line 16)
I don't think this is a particularly big issue; fix it if you like.

Not that it matters much, but you can do without dos2unix by simply calling sed:
  sed -i 's/\r//' NAME.txt

Where did the
  %{?!python:%define python python}
along with all of the %{python} macro usage come from?  I'm having a tough time understanding why you would want that.  I guess it would be useful if we had multiple python versions in the distro at once and you want to build python3-epsilon, except that everyone's been adamant that will not happen.  Given that, it just seems like noise.

I note that several of the source files carry no licensing information.  Upstream should be prodded to put that information on every source file.

I note that the tarball downloaded from the Source0: URL does not match what you have in this package.  Any reason why there's a difference?

Only the last issue is an absolute blocker, but the specfile cleanliness stuff (needlessly complex %files list, pointless %{python} macro) are things that someone else might approve, but because I'm a fan of using the minimum amount of spec file to do the job, I won't personally accept them.  There's a really nice python package template in /etc/rpmdevtools/spectemplate-python.spec which, once it's adapted, makes a nice minimal python spec file, and that's the kind of spec file that I personally like to see.  So I'm going to leave this review for someone else to look at.
Comment 7 Yaakov Nemoy 2009-07-15 09:05:25 EDT
RPM build errors:
    File not found: /builddir/build/BUILDROOT/python-epsilon-0.5.12-1.fc11.noarch/usr/lib/python2.6/site-packages/Epsilon-0.5.12_rUnknown-py2.6.egg-info


On a slightly unrelated note: why are you defining %python at the top, in the first line? it's causing some weird errors to spout when trying to create a source rpm in mock.
Comment 8 Mauricio Teixeira 2009-07-18 20:13:20 EDT
The egg-info file was being generated with rUnknown in F10, but in F11 it gets generated with r17222, so I fixed it in the new spec file.

The %python at the top was there because of some internal black magic, which is not needed anymore, so I removed. You will still see "python not found" errors in mock because of the "python_sitelib" macro (as specified by the packaging guidelines).

The new files are here:

http://mteixeira.webset.net/mock/python-epsilon.spec
http://mteixeira.webset.net/mock/python-epsilon-0.5.12-2.fc11.src.rpm

$ rpmlint mock/python-epsilon-0.5.12-2.fc11.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint mock/python-epsilon-0.5.12-2.fc11.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Thanks for your time to review this.
Comment 9 Yaakov Nemoy 2009-07-20 07:52:03 EDT
MUST: rpmlint must be run on every package. The output should be posted in the review.[1]
python-epsilon.spec: W: mixed-use-of-spaces-and-tabs (spaces: line 7, tab: line 16)
-- Not a show stopper, but should be fixed before going to rawhide.

MUST: The package must be named according to the Package Naming Guidelines .
-- CHECK

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
-- CHECK

MUST: The package must meet the Packaging Guidelines .
-- CHECK

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
-- CHECK

MUST: The License field in the package spec file must match the actual license. [3]
-- CHECK

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
-- CHECK

MUST: The spec file must be written in American English. [5]
-- CHECK

If you could call technical language 'English' :P

MUST: The spec file for the package MUST be legible. [6]
-- CHECK

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
-- CHECK

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
-- CHECK

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
-- CHECK

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
-- CHECK

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
-- CHECK

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
-- CHECK

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [11]
-- CHECK

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [12]
-- CHECK

MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [13]
-- CHECK

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]
-- CHECK

MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]
-- CHECK

MUST: Each package must consistently use macros. [16]
-- CHECK

MUST: The package must contain code, or permissable content. [17]
-- CHECK

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
-- CHECK

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
-- CHECK

MUST: Header files must be in a -devel package. [19]
-- CHECK

MUST: Static libraries must be in a -static package. [20]
-- CHECK

MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [21]
-- CHECK

MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
-- CHECK

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]
-- CHECK

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
-- CHECK

MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [23]
-- CHECK

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]
-- CHECK

MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]
-- CHECK

MUST: All filenames in rpm packages must be valid UTF-8. [26]
-- CHECK




SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.

SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [27]
-- CHECK

SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [28]
-- CHECK

SHOULD: The reviewer should test that the package builds in mock. [29]
-- CHECK

SHOULD: The package should compile and build into binary rpms on all supported architectures. [30]
-- CHECK

SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
-- CHECK

SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [31]
-- CHECK

SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [22]
-- CHECK

SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [21]
-- CHECK

SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [32] 
-- CHECK

RESOLUTION: PASS but...

If you want to be extra specially good at packaging, have a look at tibbs' comments. While i have no issue with the issues he brought up, he knows what he's doing much much better than i. Most important is to convince upstream to include a license in every single source file distributed. There is a strong benefit for upstream there. An email would suffice. The rest of the issues are more a matter of style.

Thanks for the submission!
Comment 10 Miroslav Suchý 2012-12-11 17:00:10 EST
Ping? Any progress here? Or we can close this review?
Comment 11 Miroslav Suchý 2013-02-19 06:02:31 EST
Stalled Review. Closing per:
https://fedoraproject.org/wiki/Policy_for_stalled_package_reviews
If you ever want to continue with this review, please reopen or
submit new review.

Note You need to log in before you can comment on or make changes to this bug.